<?php
/**
 *
 * Copyright(c) 2006-2019 ThreatSTOP, Inc. All Rights Reserved
 *
 * NOTICE: All information contained herein is, and remains the property
 * of ThreatSTOP, Inc. and its suppliers, if any. The intellectual and
 * technical concepts contained herein are proprietary to ThreatSTOP, Inc.
 * and its suppliers and certain aspects thereof are protected by United
 * States Patent No. 8,533,822 and United States Patent No. 8,869,237,
 * and are protected by trade secret or copyright law.
 *
 * US Government Entities: The ThreatSTOP service, software and
 * documentation, as applicable, are "commercial computer software" and
 * "commercial computer software documentation" developed exclusively at
 * private expense by Threatstop, Inc. ("Threatstop"). Pursuant to FAR
 * 12.212 or DFARS 227 7202 and their successors, as applicable, use,
 * reproduction and disclosure of the software and documentation is
 * governed by the terms of Threatstop's commercial agreement.
 */

require_once("/usr/local/www/threatstop.conf.php"); // TDID


// reads the logfile and parses the dates into epoch timestamps
// returns enumerated line number when the first new timestamp is encountered
function get_last_timestamp_position($lines) {

    // $lines = explode("\n", $lines);
    // echo "Lines: " . count($lines) . "\n";

    $i = 0;
    $first_new = 0;
    if (file_exists('/root/.threatstop_last_upload')) {
        $first_new = shell_exec("cat /root/.threatstop_last_upload | tr -d '\n' 2> /dev/null");
    }
    $orig_first_new = $first_new;
    // echo "original first_new: $orig_first_new \n";

    foreach ($lines as $line) {
        // echo "$orig_line \n";
        $line = str_replace(' pfSense ', '', explode('filterlog:', $line)[0]);
        if (! $line) {
            $i++;
            continue;
        }
        $timestamp = strtotime($line);
        if (! $timestamp or $timestamp < 1555000000 ) {
            $i++;
            continue;
        }
        // echo "strtotime: $timestamp \n";
        if ($timestamp > $first_new) {
            //echo "we have a new start point [$i] $ndate[0]";
            $now = time();
            // echo "Updating last log line uploaded: $now\n";
            shell_exec("printf '$now' > /root/.threatstop_last_upload");
            // shell_exec("printf '$timestamp' > /root/.threatstop_last_upload");
            return $i;
        }
        $i++;
    }
    echo "Read through entire file without finding a spot to resume.\n";
    $now = time();
    shell_exec("printf '$now' > /root/.threatstop_last_upload");
    return $i;
}


// $content    = shell_exec("/usr/local/sbin/clog $argv[1]");
$content    = shell_exec("%clog% $argv[1]");
$lines = explode("\n", $content);

//$content    = shell_exec("$(which clog) $argv[1]");
// This looks like it used to be a marker to find last uploaded position.
// Doesn't seem to work any longer
shell_exec('/usr/bin/logger -p local0.info "ThreatSTOP log upload"');
$startpos = get_last_timestamp_position($lines);
// echo "Starting at $startpos\n";
// echo "Line to resume: $lines[$startpos]\n";
if ($startpos == count($lines) or $startpos == count($lines) - 1) {
    die("nothing new to upload..\n");
}
else {
    // $content = substr($content, $startpos);
    $content = implode("\n", array_slice($lines, $startpos));
}
// echo "Resuming at: $startpos >> $lines[$startpos] ";
// $nl = explode("\n", $content);
// echo "first line: $nl[0]\n";
// die();
$ip      = 'ssl://logs.threatstop.com';
$host    = 'logs.threatstop.com';
$md5     = md5($content);
$len     = strlen($content);

# Don't upload if no log present
if ($len == 0) {
    exit;
}

//echo "$md5 $len\n";
$sp = fsockopen($ip, 443, $errno, $errstr, 10);

if (!$sp) {
    die("error: $errstr ($errno)" . "\r\n");
}

$boundary = str_repeat('-', 10) . time();

$body = '--' . $boundary . "\r\n";
$body .= "Content-Disposition: form-data; name=\"md5_client\"\r\n\r\n";
$body .= $md5."\r\n";
$body .= '--' . $boundary . "\r\n";
$body .= "Content-Disposition: form-data; name=\"upfile_size\"\r\n\r\n";
$body .= "$len\r\n";
$body .= '--' . $boundary . "\r\n";
if ($TDID) {
  $body .= "Content-Disposition: form-data; name=\"fw_tdid\"\r\n\r\n";
  $body .= "$TDID\r\n";
  $body .= '--' . $boundary . "\r\n";
}
//$body .= "Content-Disposition: form-data; name=\"fw_ip\"\r\n\r\n";
//$body .= $ip"\r\n";
//$body .= '--' . $boundary . "\r\n";
$body .= "Content-Disposition: form-data; name=\"upfile\"; filename=\"log\"\r\n";
$body .= "Content-Type: text/plain\r\n";
$body .= "Content-Transfer-Encoding: binary\r\n\r\n";
$body .= $content . "\r\n";
$body .= "--$boundary--\r\n";

$query  = 'POST /cgi-bin/logupload.pl HTTP/1.1' . "\r\n";
$query .= 'HOST: ' . $host . "\r\n";
$query .= 'Content-type: multipart/form-data; boundary=' . $boundary . "\r\n";
$query .= 'Connection: Keep-Alive' . "\r\n";
$query .= 'Content-Length: ' . strlen($body) . "\r\n";
$query .= "Accept:*/*\r\n\r\n";
$query .= $body;

$result = fwrite($sp, $query . "\r\n");
$result2 = fread($sp, 10000000);
//var_dump($result, $result2);


